<template>
    <div class="filter">
        <div v-for="(field, index) in fields" :key="index" class="field">
            <label>{{ field.label }}</label>
            <div v-if="field.type === 'text'">
                <input type="text" v-model="filters[field.key]">
            </div>
            <div v-else-if="field.type === 'select'">
                <select v-model="filters[field.key]">
                    <option v-for="option in field.options" :value="option.id">{{ option.name }}</option>
                </select>
            </div>
        </div>
        <div class="field">
            <label></label>
            <button class="submit" @click="search">Search</button>
            &nbsp;
            <button class="submit" @click="clearFilters">Clear</button>
        </div>
    </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue'

interface Option {
    id: string,
    name: string
}
interface FilterField {
    key: string
    label: string
    type: 'text' | 'select'
    options?: Option[]
}

interface Filters {
    [key: string]: string | string[]
}

export default defineComponent({
    name: 'Filter',
    data() {
        return {
            fields: [] as FilterField[],
            filters: {} as Filters
        }
    },
    async mounted() {
        try {
            const res = await this.$axios.get('config')
            this.fields = <FilterField[]>res.data.fields

            Object.keys(this.fields).forEach(field => {
                this.filters[this.fields[field].key] = ''
            })
        } catch (e) {
            console.log(e)
        }
    },
    methods: {
        search() {
            this.$emit('search', this.filters)
        },

        clearFilters() {
            Object.keys(this.filters).forEach(key => {
                this.filters[key] = ''
            })

            this.$emit('clear')
        }
    }
})
</script>

<style>
.filter {
    display: flex;
    flex-wrap: wrap;
}

.field {
    margin-right: 20px;
    margin-bottom: 10px;
}
</style>
